.\"	$NetBSD: rpc.statd.8,v 1.5 2002/12/21 12:47:21 wiz Exp $
.\"
.\" Copyright (c) 1995 A.R.Gordon, andrew.gordon@net-tel.co.uk
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"
.Dd September 19, 1995
.Dt RPC.STATD 8
.Os
.Sh NAME
.Nm rpc.statd
.Nd host status monitoring daemon
.Sh SYNOPSIS
.Nm
.Op Fl d
.Sh DESCRIPTION
.Nm
is a daemon which co-operates with rpc.statd daemons on other hosts to provide
a status monitoring service.  The daemon accepts requests from
programs running on the local host (typically,
.Xr rpc.lockd 8 ,
the NFS file locking daemon) to monitor the status of specified
hosts.  If a monitored host crashes and restarts, the remote daemon will
notify the local daemon, which in turn will notify the local program(s)
which requested the monitoring service.  Conversely, if this host crashes
and restarts, when
.Nm
restarts, it will notify all of the hosts which were being monitored
at the time of the crash.
.Pp
Options and operands available for
.Nm
:
.Bl -tag -width Ds
.It Fl d
The
.Fl d
option causes debugging information to be written to syslog, recording
all RPC transactions to the daemon.  These messages are logged with level
LOG_DEBUG and facility LOG_DAEMON.  Error conditions are logged irrespective
of this option, using level LOG_ERR.
.El
.Pp
The
.Nm
daemon must NOT be invoked by
.Xr inetd 8
because the protocol assumes that the daemon will run from system start time.
Instead, it should be configured in
.Xr rc.conf 5
to run at system startup.
.Sh FILES
.Bl -tag -width /usr/include/rpcsvc/sm_inter.x -compact
.It Pa /var/db/statd.status
non-volatile record of currently monitored hosts.
.It Pa /usr/include/rpcsvc/sm_inter.x
RPC protocol specification used by local applications to register monitoring requests.
.El
.Sh SEE ALSO
.Xr syslog 3 ,
.Xr rc.conf 5 ,
.Xr rpc.lockd 8
.Sh STANDARDS
The implementation is based on the specification in X/Open CAE Specification
C218, "Protocols for X/Open PC Interworking: XNFS, Issue 4", ISBN 1 872630 66 9
.Sh HISTORY
A version of
.Nm
appeared in
.Tn SunOS 4 .
.Sh BUGS
There is no means for the daemon to tell when a monitored host has
disappeared permanently (e.g., catastrophic hardware failure), as opposed
to transient failure of the host or an intermediate router.  At present,
it will retry notification attempts at frequent intervals for 10 minutes,
then hourly, and finally gives up after 24 hours.
.Pp
The protocol requires that symmetric monitor requests are made to both
the local and remote daemon in order to establish a monitored relationship.
This is convenient for the NFS locking protocol, but probably reduces the
usefulness of the monitoring system for other applications.
.Pp
The current implementation uses more than 1Kbyte per monitored host in
the status file (and also in VM).  This may be inefficient for NFS servers
with large numbers of clients.
